// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package proto_def

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SDPClient is the client API for SDP service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SDPClient interface {
	RecordEvents(ctx context.Context, opts ...grpc.CallOption) (SDP_RecordEventsClient, error)
}

type sDPClient struct {
	cc grpc.ClientConnInterface
}

func NewSDPClient(cc grpc.ClientConnInterface) SDPClient {
	return &sDPClient{cc}
}

func (c *sDPClient) RecordEvents(ctx context.Context, opts ...grpc.CallOption) (SDP_RecordEventsClient, error) {
	stream, err := c.cc.NewStream(ctx, &SDP_ServiceDesc.Streams[0], "/SDP/RecordEvents", opts...)
	if err != nil {
		return nil, err
	}
	x := &sDPRecordEventsClient{stream}
	return x, nil
}

type SDP_RecordEventsClient interface {
	Send(*ParsedEventMessage) error
	CloseAndRecv() (*ParsedEventResponse, error)
	grpc.ClientStream
}

type sDPRecordEventsClient struct {
	grpc.ClientStream
}

func (x *sDPRecordEventsClient) Send(m *ParsedEventMessage) error {
	return x.ClientStream.SendMsg(m)
}

func (x *sDPRecordEventsClient) CloseAndRecv() (*ParsedEventResponse, error) {
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	m := new(ParsedEventResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// SDPServer is the server API for SDP service.
// All implementations must embed UnimplementedSDPServer
// for forward compatibility
type SDPServer interface {
	RecordEvents(SDP_RecordEventsServer) error
	mustEmbedUnimplementedSDPServer()
}

// UnimplementedSDPServer must be embedded to have forward compatible implementations.
type UnimplementedSDPServer struct {
}

func (UnimplementedSDPServer) RecordEvents(SDP_RecordEventsServer) error {
	return status.Errorf(codes.Unimplemented, "method RecordEvents not implemented")
}
func (UnimplementedSDPServer) mustEmbedUnimplementedSDPServer() {}

// UnsafeSDPServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SDPServer will
// result in compilation errors.
type UnsafeSDPServer interface {
	mustEmbedUnimplementedSDPServer()
}

func RegisterSDPServer(s grpc.ServiceRegistrar, srv SDPServer) {
	s.RegisterService(&SDP_ServiceDesc, srv)
}

func _SDP_RecordEvents_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(SDPServer).RecordEvents(&sDPRecordEventsServer{stream})
}

type SDP_RecordEventsServer interface {
	SendAndClose(*ParsedEventResponse) error
	Recv() (*ParsedEventMessage, error)
	grpc.ServerStream
}

type sDPRecordEventsServer struct {
	grpc.ServerStream
}

func (x *sDPRecordEventsServer) SendAndClose(m *ParsedEventResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *sDPRecordEventsServer) Recv() (*ParsedEventMessage, error) {
	m := new(ParsedEventMessage)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// SDP_ServiceDesc is the grpc.ServiceDesc for SDP service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var SDP_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "SDP",
	HandlerType: (*SDPServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "RecordEvents",
			Handler:       _SDP_RecordEvents_Handler,
			ClientStreams: true,
		},
	},
	Metadata: "proto_def/SDP.proto",
}
